<template>
  <div>
    <ClientOnly>
      <VueCodeBlock v-if="finished" v-bind="props" prismjs />
      <template #fallback>
        <div class="block">
          <pre class="flex h-auto overflow-auto rounded-lg bg-black p-4">
			<code>{{ props.code }}</code>
		</pre>
        </div>
      </template>
    </ClientOnly>
  </div>
</template>

<script setup lang="ts">
import VueCodeBlock from "vue3-code-block";
import type { Props } from "vue3-code-block";

const finished = ref(false);
onBeforeMount(async () => {
  const prism = await import("prismjs");
  // @ts-ignore
  await import("prismjs/components/prism-bash");
  finished.value = true;
});

const props = withDefaults(defineProps<Props>(), {
  browserWindow: false,
  code: "",
  codeBlockRadius: "0.5rem",
  copyButton: true,
  copyIcons: true,
  copyTab: true,
  copyFailedText: "Copy failed!",
  copyText: "Copy Code",
  copySuccessText: "Copied!",
  floatingTabs: true,
  height: "auto",
  highlightjs: false,
  indent: 2,
  label: "",
  lang: "javascript",
  maxHeight: "auto",
  persistentCopyButton: false,
  prismjs: false,
  prismPlugin: false,
  runTab: false,
  runText: "Run",
  tabGap: "0.25rem",
  tabs: false,
  theme: "neon-bunny",
});
</script>
